stages:
  - build
  - kaniko
  - env
  - test
  - staging
  - production

# build
build:
  stage: build
  script:
    - echo "This is some text" > my_file.txt
  artifacts:
    paths:
      - my_file.txt
    # If not set, use default expiration
    expire_in: 1 week

kaniko build:
  stage: kaniko
  script:
    - echo "filler text"
# END build

# test
env:
  stage: env
  script:
    - env
test:
  stage: test
  before_script:
    - TXT_RED="\e[31m" && TXT_CLEAR="\e[0m"
    - echo "download stuff"
  script:
    - echo "dummy test"
    - echo -e "${TXT_RED}This text is red,${TXT_CLEAR} but this part isn't${TXT_RED} however this part is again."
# END test

# Stage deploy
staging deploy:
  stage: staging
  # TODO: Add build timeout (https://docs.gitlab.com/ee/ci/yaml/#timeout)
  script:
    - echo "dummy deploy staging"
  after_script:
    - echo "dummy validate staging deploy"
# END stage deploy

# Prod deploy
production deploy:
  stage: production
  # TODO: Require user input for run (https://docs.gitlab.com/ee/ci/yaml/#when)
  # TODO: Block futher execution until this job is done (https://docs.gitlab.com/ee/ci/yaml/#rulesallow_failure)
  script:
    - echo "dummy deploy production"
  after_script:
    - echo "dummy validate production deploy"
# END prod deploy

post success:
  stage: .post
  # TODO: Make this run when successful (https://docs.gitlab.com/ee/ci/yaml/#when)
  script:
    - echo "notify success!"

post failure:
  stage: .post
  # TODO: Make this run when failure (https://docs.gitlab.com/ee/ci/yaml/#when)
  script:
    - echo "notify failure"

